#include <linux/limits.h>
#include <stdio.h>
#include <stdarg.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <netdb.h>
#include "ytcp_server.h"
#include "ylog.h"

#define SERVICE			"the_service"
#define PROTOCOL		"tcp"
#define PORT			11137
#define SERVICE_PORT		"THE_SERVICE_PORT"

/*#define USE_STREAM*/

void *mafonc(void *);

void *mafonc(void *param)
{
#ifdef USE_STREAM
  int c;
  FILE *file = YTCP_THREAD_STREAM(param);
#else /* USE_STREAM */
  char s[512];
  int i, sock = YTCP_THREAD_SOCK(param);
#endif /* USE_STREAM */

  printf("In thread\n");
#ifdef USE_STREAM
  while ((c = fgetc(file)) != EOF)
    {
      printf("Read ('%c')\n", c);
      fputc(c, file);
    }
#else /* USE_STREAM */
  while ((i = read(sock, s, 511)) > 0)
    {
      s[i] = '\0';
      printf("Read ('%s') %d\n", s, i);
      write(sock, s, strlen(s));
    }
#endif /* USE_STREAM */
  printf("Stop. close\n");
  printf("ciao\n");
  return (NULL);
}

int main(int argc, char **argv)
{
  struct servent *serv;
  char *serv_env;
  int fd, port_num;
  ytcp_server_t *server;

  /* detach process
  if (fork() != 0)
    exit(0);
  setsid(); */
  /* close all file descriptors
  for (fd = 0; fd < OPEN_MAX; ++fd)
    close(fd);
  chdir("/"); */
  umask(0);

  YLOG_INIT_STDERR();
  YLOG_SET_INFO();

  /* get port number */
  if (argc == 2)
    port_num = atoi(argv[1]);
  else if ((serv_env = getenv(SERVICE_PORT)) && strlen(serv_env))
    port_num = atoi(serv_env);
  else if ((serv = getservbyname(SERVICE, PROTOCOL)))
    port_num = serv->s_port;
  else
    port_num = PORT;

  YLOG_ADD(YLOG_NOTE, "port=%d", port_num);

  server = ytcp_server_init(0, mafonc, NULL);
  if (ytcp_server_start(server, port_num) != YENOERR)
    {
      server = ytcp_server_delete(server, 0);
      exit(1);
    }
  server = ytcp_server_delete(server, 0);
  YLOG_END();

  return (0);
}
