/*
 ** tcp_client_server.c
 ** 
 ** Made by (amaury bouchard)
 ** Login   <boucha_a@epita.fr>
 ** 
 ** Started on  Sat Jul 10 10:53:45 1999 amaury bouchard
 ** Last update Sat Jul 10 12:05:52 1999 amaury bouchard
 */
#include "tcp.h"

/*
** init_tcp_env() -- 13 lignes
** initialise une structure t_tcp_env
*/

t_tcp_env	*init_tcp_env(socket_type,port,server_name,data)
int		socket_type;
int		port;
char		*server_name;
void		*data;
{
   t_tcp_env	*env;
   int		i;

   env = malloc(sizeof(t_tcp_env));
   env->port = port;
   env->server_name = server_name;
   env->data = data;
   env->fdtablesize = getdtablesize();
   env->fd_table = malloc(sizeof(t_fd_table)*env->fdtablesize);
   for (i = 0 ;i < env->fdtablesize;i++)
      env->fd_table[i].state = FD_STATE_NOT_USED;
   env->sd_connect = create_tcp_socket(socket_type,port,server_name);
   return (env);
}

/*
** make_active_fd() -- 2 lignes
** associe une fonction a un file descriptor
** utile pour les fd autres que provenant de la connexion client-server
*/

void		make_active_fd(env,fd,fonc)
t_tcp_env	*env;
int		fd;
void		(*fonc)();
{
   env->fd_table[fd].state = FD_STATE_USED;
   env->fd_table[fd].fonc = fonc;
}

/*
** make_inactive_fd() -- 1 ligne
** rend inactif le file descriptor voulu
*/

void		make_inactive_fd(env,fd)
t_tcp_env	*env;
int		fd;
{
   env->fd_table[fd].state = FD_STATE_NOT_USED;
}

/*
** create_tcp_socket() -- 23 lignes
** cree une socket
** suivant le type de socket demande (pour un client ou pour un serveur),
** cette socket sera bindee ou connectee
*/

int			create_tcp_socket(socket_type,port,server_name)
int			socket_type;
int			port;
char			*server_name;
{
   int			sd;
   struct sockaddr_in	addr;
   struct hostent	*host_info;
   
   sd = socket(AF_INET,SOCK_STREAM,0);
   addr.sin_family = AF_INET;
   addr.sin_port = htons(port);
   if (socket_type == CLIENT_SOCK)
   {
      if ((host_info = gethostbyname(server_name)) == 0)
	 TCP_ERROR_QUIT("gethostbyname error");
      bcopy(host_info->h_addr,&(addr.sin_addr.s_addr),host_info->h_length);
      if (connect(sd,(void*)&addr,sizeof(struct sockaddr_in)) < 0)
	 TCP_ERROR_QUIT("Connection error");
   }
   else if (socket_type == SERVER_SOCK)
   {
      addr.sin_addr.s_addr = htonl(INADDR_ANY);
      if (bind(sd,(struct sockaddr*)&addr,sizeof(addr)) < 0)   
	 TCP_ERROR_QUIT("Server connecting");
      listen(sd,10);
   }
   return (sd);
}
