/*
 ** tcp_server.c
 ** 
 ** Made by (amaury bouchard)
 ** Login   <boucha_a@epita.fr>
 ** 
 ** Started on  Sat Jul 10 10:37:40 1999 amaury bouchard
 ** Last update Sat Jul 10 12:21:54 1999 amaury bouchard
 */
#include "tcp.h"

/*
** create_tcp_server() -- 32 lignes
** cree le server, et boucle sur les file descriptors
*/

void		create_tcp_server(env,loop_cond,fonc)
t_tcp_env	*env;
int		*loop_cond;
void		(*fonc)();
{
   int			i;
   int			new_fd;
   struct sockaddr_in	name;
   int			size;

   env->max_fd_connected = env->sd_connect;
   env->fd_table[env->sd_connect].state = FD_STATE_USED;
   env->fd_table[env->sd_connect].fonc = fonc;
   env->loop_condition = loop_cond;
   while (*(env->loop_condition))
   {
      FD_ZERO(&env->sread);
      for (i = 0 ;i < env->fdtablesize;i++)
	 if (env->fd_table[i].state & FD_STATE_USED)
	 {
	    FD_SET(i,&env->sread);
	    env->max_fd_connected = i + 1;
	 }
      if (select(env->max_fd_connected,&env->sread,0,0,0)<0)
	 TCP_ERROR_CONTINUE("select");
      for (i = 0 ;i < env->fdtablesize;i++)
	 if ((env->fd_table[i].state & FD_STATE_USED) && FD_ISSET(i,&env->sread))
	    if (i == env->sd_connect)
	    {
	       new_fd = accept(i,(void*)&name,&size);
	       env->fd_table[new_fd].state = FD_STATE_USED;
	       env->fd_table[new_fd].fonc = env->fd_table[i].fonc;
	       break;
	    }
	    else
	       env->fd_table[i].fonc(i,env);
   }
}

/*
** create_tcp_client() -- 21 lignes
** cree le client, et boucle sur les file descriptors
*/

void		create_tcp_client(env,loop_cond,fonc)
t_tcp_env	*env;
int		*loop_cond;
void		(*fonc)();
{
   int		i;

   env->max_fd_connected = env->sd_connect;
   env->fd_table[env->sd_connect].state = FD_STATE_USED;
   env->fd_table[env->sd_connect].fonc = fonc;
   env->loop_condition = loop_cond;
   while (*(env->loop_condition))
   {
      FD_ZERO(&env->sread);
      for (i = 0 ;i < env->fdtablesize;i++)
	 if (env->fd_table[i].state & FD_STATE_USED)
	 {
	    FD_SET(i,&env->sread);
	    env->max_fd_connected = i + 1;
	 }
      if (select(env->sd_connect+1,&env->sread,0,0,0)<0)
         TCP_ERROR_CONTINUE("select");
      for (i = 0 ;i < env->fdtablesize;i++)
	 if ((env->fd_table[i].state & FD_STATE_USED) && FD_ISSET(i,&env->sread))
	    env->fd_table[i].fonc(i,env);
   }
}
