/*
 ** trac_chrono.c
 ** 
 ** Made by (amaury bouchard)
 ** Login   <boucha_a@epita.fr>
 ** 
 ** Started on  Mon Sep 27 14:22:36 1999 amaury bouchard
 ** Last update Mon Sep 27 14:46:55 1999 amaury bouchard
 */
#include "trac_chrono.h"

// chronoStart()
// enclenche le debut du chronometrage

ClassChrono*	chronoStart(ClassChrono* this)
{
  if (this->active)
    return (0);
  this->active = 1;
  gettimeofday(&this->start,NULL);
  return (this);
}

// chronoStop()
// arrete le chronometrage

ClassChrono*	chronoStop(ClassChrono* this)
{
  if (!this->active)
    return (0);
  gettimeofday(&this->end,NULL);
  if (this->start.tv_usec > this->end.tv_usec)
    {
      this->end.tv_usec += 1000000;
      this->end.tv_sec--;
    }
  this->active = 0;
  return (this);
}

// chronoReset()
// remet le chronometre a zero

ClassChrono*	chronoReset(ClassChrono* this)
{
  this->active = 1;
  gettimeofday(&this->start,NULL);
  return (this);  
}

// chronoGetSeconds()
// retourne le temps de chronometrage en secondes

int	chronoGetSeconds(ClassChrono* this)
{
  int	result;

  if (this->active)
    return (0);
  result = (this->end.tv_sec - this->start.tv_sec);
  return (result);
}

// chronoGetUSeconds()
// retourne le temps de chronometrage en microsecondes

int	chronoGetUSeconds(ClassChrono* this)
{
  int	result;

  if (this->active)
    return (0);
  result = (this->end.tv_sec - this->start.tv_sec) * 1e6;
  result += (this->end.tv_usec - this->start.tv_usec);
  return (result);
}

// newClassChrono()
// constructeur de l'objet ClassChrono

ClassChrono*	newClassChrono(ClassChrono* this)
{
  initParentClass(this,deleteClassChrono);
  return (this);
}

// deleteClassChrono()
// destructeur de l'objet ClassChrono

void	deleteClassChrono(ClassChrono* this)
{
}
