// Base de donnees
// noms des champs limites a 256 caracteres
// taillle des enregistrements limitee a 999 999 octets
#ifndef __TRAC_DB_H__
#define	__TRAC_DB_H__

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "trac.h"

// definition du nom du fichier contenant les definitions des champs
#define	FIELDS_FILE		"fields.db"

// definition du nom du fichier contenant la base de donnees
#define	DB_FILE			"tracdb.db"

// definition du caractere precedant chaque enregistrement et signifiant
// que l'espace memoire est utilise
#define	USED_RECORD		'A'

// definition du caractere precedant chaque enregistrement et signifiant
// que l'espace memoire est libre
#define	FREE_RECORD		'Z'

// definition des statuts possibles de la base de donnees
#define	DB_STATUS_CLOSED	2
#define	DB_STATUS_OPENED	1
#define	DB_STATUS_BAD		0

class
{
  noextends;
  int		status;		// statut courant de la base de donnees
  char*		path;		// chemin vers la base de donnees
  int		nbOfFields;	// nombre de champs d'un enregistrement
  char**	fieldsName;	// tableau des noms des champs
  int*		fieldsSize;	// tableau des tailles des champs
  int		recordSize;	// taille totale d'un enregistrement
  int		fd;		// file descriptor vers les donnees
  int		databaseSize;	// taille de la base de donnees
  int		nbOfRecords;	// nombre d'enregistrements de la base
}		ClassDB;

// Prototypes
int		dbOpen(ClassDB*);
int		dbCreate(ClassDB*,char*,char*);
int		dbClose(ClassDB*);
int		dbSetDataBase(ClassDB*,char*);

int		dbFindField(ClassDB*,char*);
char**		dbGetRecord(ClassDB*,char**,char**);
char*		dbGetFieldOfRecord(ClassDB*,char*,char*);
int		dbDeleteRecord(ClassDB*,char**,char**);
int		dbUpdateRecord(ClassDB*,char**,char**,char*,char*);
int		dbAddRecord(ClassDB*,char*);
char*		dbCreateRecordString(ClassDB*,char*,char*,char*);

ClassDB*	newClassDB(ClassDB*,char*);
void		deleteClassDB(ClassDB*);

#endif // __TRAC_DB_H__
