#include "trac_db.h"

// =============================================================================
// fonctions publiques
// =============================================================================

// dbCreate()
// fonction qui cree une nouvelle base de donnees
// retourne 0 si la base existe deja ou s'il est impossible de la creer, 1 sinon
// recoit en parametre une chaine de caractere conrtenant le chemin vers la base
// et une autre decrivant la base, de la forme
// nbre_de_champs:taille_totale:champ1=taille&champ2=taille...
int	dbCreate(ClassDB* this,char* path,char* description)
{
  int	size;
  char*	tmp;
  char	c[2];
  int	fd;

  if (mkdir(path,0600))
    return (0);
  c[0] = '/'; c[1] = 0;
  size = strlen(path) + 1 + strlen(FIELDS_FILE);
  tmp = (char*)malloc(size+1);
  strcpy(tmp,path);
  strcat(tmp,c);
  strcat(tmp,FIELDS_FILE);
  if ((fd = open(tmp,O_CREAT | O_WRONLY,0600)) < 0)
    {
      this->status = DB_STATUS_BAD;
      return (0);
    }
  free(tmp);
  size = strlen(description);
  if (write(fd,description,size) != size)
    {
      this->status = DB_STATUS_BAD;
      return (0);
    }
  close(fd);
  size = strlen(path) + 1 + strlen(DB_FILE);
  tmp = (char*)malloc(size+1);
  strcpy(tmp,path);
  strcat(tmp,c);
  strcat(tmp,DB_FILE);
  if ((fd = creat(tmp,0600)) < 0)
    {
      this->status = DB_STATUS_BAD;
      return (0);
    }
  close(fd);
  this->status = DB_STATUS_CLOSED;
  return (1);
}

// dbClose()
// permet de fermer l'acces a une base de donnees
// retourne 1 si l'operation s'est bien deroulee, 0 sinon
int	dbClose(ClassDB* this)
{
  if (this->status == DB_STATUS_BAD)
    return (0);
  if (this->status == DB_STATUS_CLOSED)
    return (1);
  close(this->fd);
  this->status = DB_STATUS_CLOSED;
  return (1);
}

// dbSetDataBase()
// fonction permettant a l'objet de se connecter a une autre base de donnees
// retourne 1 si la base precedente n'est pas ouverte, 0 sinon
int	dbSetDataBase(ClassDB* this,char* newPath)
{
  if (this->status == DB_STATUS_OPENED)
    return (0);
  this->path = newPath;
  return (1);
}
