#ifndef	__TRAC_DEFINE_H__
#define	__TRAC_DEFINE_H__

// definition de macro pour signifier qu'un objet n'est pas encore cree
#define	OBJECT_PREPARING	0

// definition de macro signifiant qu'un objet est cree
#define	OBJECT_EXIST		1

// definition de macro signifiant qu'un objet est detruit
#define	OBJECT_FREE		2

// definition de macro pour allouer une zone memoire remplie de zeros
// t : nom de l'objet
// ex : ClassMyObject*	pt = new(ClassMyObject);
#define	new(t)		(t*)memset((void*)malloc(sizeof(t)),0,sizeof(t))

// definition de macro pour verifier qu'une fonction polymorphe a ete assignee
// f : pointeur sur la methode abstraite
// ex dans le constructeur : polymorph(this->myFunction);
// avec this etant un pointeur sur l'objet
#define	virtual(f)	if (!f) {perror("Trying to allocate a virtual object");exit (1);}

// definition de macro pour obtenir un pointeur sur le parent d'un pointeur
// ex : herit(b,ClassA)->toto  permet d'atteindre l'attribut toto defini dans
// l'objet ClassA, alors que l'on a un pointeur sur un ClassB, qui herite de ClassA
// o : pointeur sur l'objet
// p : nom de l'objet parent
#define	herit(o,p)	((p*)o)

// defintion de macro pour rendre concrete une methode abstraite d'un objet parent
// o : pointeur sur l'objet
// p : nom de l'objet parent
// a : nom de la methode abstraite dans l'objet parent
// c : nom de la fonction concrete qui doit remplacer la methode abstraite
#define	polymorph(o,p,a,c)	(((p*)o)->a) = c

// definition de macro pour specifier qu'un objet n'herite d'aucun objet
#define	noextends			ClassObject obj

// definition de macro pour specifier qu'un objet herite d'un autre
#define	extends(p)			p parent;ClassObject obj

// definition de macro servant a initialiser un objet parent
#define	initParentClass(o,delo)		newObject(o,&(o->obj),0,delo)

// definition de macro servant a initialiser un objet enfant
#define	initChildClass(o,p,delo)	newObject(o,&(o->obj),&(((p*)o)->obj),delo)

// definition de macro servant pour les conventions d'ecriture
#define	class				typedef struct

// definition de macro servant pour detruire un objet
#define	delete(o)			deleteObject(&(o->obj))

#endif	// __TRAC_DEFINE_H__
