#ifndef	__TRAC_EXCEPTION_H__
#define	__TRAC_EXCEPTION_H__

#include <stdio.h>
#include <unistd.h>
#include <setjmp.h>

// dfinition de la valeur d'exception
#define	TRAC_EXCEPTION	11137

// dfinition de la macro d'ajout d'exception
#define	try		pushException(); \
			_exceptResult = setjmp(_exceptions->env); \
			if (!_exceptResult)

// dfinition de la macro de gestion d'exception
#define	except		else {{ \
			  if (_exceptions && _exceptions->propagate && \
			      _exceptions->show && _exceptions->msg) \
			    fprintf(stderr, "%s line %d : \t%s\n", \
			    _exceptions->file, _exceptions->line, \
			    _exceptions->msg); \
			  }

// dfinition de la macro de fin d'exception
#define	endExcept	} \
			popException(_exceptResult)

// dfinition de la macro de gnration d'exception
#define	raise(msg)	raiseException(msg, __FILE__, __LINE__)

// dfinition de la macro permettant de ne pas propager l'exception
#define	catchExcept	_exceptions->propagate = 0;

// dfinition de la macro rtablissant la propagation de l'exception
#define throwExcept	_exception->propagate = 1;

// dfinition de la structure

typedef struct		sException
{
  jmp_buf		env;
  char*			msg;
  char*			file;
  int			line;
  unsigned int		propagate : 1;
  unsigned int		show : 1;
  struct sException	*super;
}			tException;

// dfinition du pointeur global sur exception

#ifndef	__TRAC_EXCEPTION_C__
extern tException	*_exceptions;
extern int		_exceptResult;
#endif

// prototypes
void	pushException();
void	popException(int exceptResult);
void	raiseException(char* msg, char* file, int line);

#endif	// __TRAC_EXCEPTION_H__
