#ifndef	__TRAC_LIST_H__
#define	__TRAC_LIST_H__

#include "trac.h"

typedef struct		sListElem
{
  struct sListElem*	prev;
  struct sListElem*	next;
  void*			elem;
}			tListElem;

class
{
  noextends;
  tListElem*	start;
  tListElem*	end;
  int		nbOfElem;
  int		iterator;
  tListElem*	iteratorPointer;
}		ClassList;

// Prototypes
ClassList*	listPutStart(ClassList* this, void* elem);
ClassList*	listPutEnd(ClassList* this, void* elem);
void*		listFind(ClassList* this, void* elem, int (*cmp)());
tListElem*	listFindCell(ClassList* this, void* elem, int (*cmp)());
void		listRmElem(ClassList* this, void* elem, int (*cmp)());
void		listRmCell(ClassList* this, tListElem* cell);
void		listRmNbr(ClassList* this, int nb);
void		listSort(ClassList* this, int (*cmp)());
void		listResetIterator(ClassList* this);
void*		listGetNextElem(ClassList* this);
void		listReverse(ClassList* this);

ClassList*	newClassList(ClassList* this);
void		deleteClassList(ClassList* this);

#endif	// __TRAC_LIST_H__
