#include "trac_object.h"

// newObject()
// initialise un nouvel objet ClassObject, en lui assignant l'adresse du
// destructeur de l'objet dont il herite

void*		newObject(void* object,void* this,void* objParent,
			  void (*deleteThis)())
{
  ClassObject*	obj;

  obj = this;
  obj->adress = object;
  obj->objParent = objParent;
  obj->status = OBJECT_EXIST;
  obj->deleteThis = deleteThis;
  return (obj);
}

// deleteObject()
// lors de la destruction d'un ClassObject, appelle la destruction de l'objet
// dont il herite, sinon libere toute la memoire allouee pour cet objet

void		deleteObject(void* pt)
{
  ClassObject*	obj;

  obj = pt;
  if (obj->status == OBJECT_EXIST)
    {
      obj->deleteThis(obj->adress);
      obj->status = OBJECT_FREE;
    }
  else
    {
      perror("Trying to delete a non-allocated object");
      exit (1);
    }
  if (obj->objParent)
    deleteObject(obj->objParent);
  else
    free(pt);
}
