#ifndef	__TRAC_STREAM_H__
#define	__TRAC_STREAM_H__

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "trac.h"

// definition de la taille du buffer
#define	STREAM_BUFF_SIZE	8192

// definitions des differents types que peut prendre un stream
#define	STREAM_CLOSED	(0 << 0)
#define	STREAM_OPENED	(1 << 0)
#define	STREAM_IO	(0 << 1)
#define	STREAM_FILE	(1 << 1)
#define	STREAM_READ	(1 << 2)
#define	STREAM_WRITE	(1 << 3)

// objet ClassStream
// type		champs de 3 bits renseignant sur le type du stream
//		bit 0 : stream ferme (valeur 0) ou ouvert (valeur 1)
//		bit 1 : stream sur file descriptor (0) ou sur fichier (1)
//		bit 2 : stream en lecture (1)
//		bit 3 : stream en ecriture (1)
// fd		file descriptor du stream
// flags	mode d'ouverture du stream (lecteure, ecriture, creation, ...)
// mode		droits sur le fichier
// readBuff	buffer en lecture
// writeBuff	buffer en ecriture
// readPos	position dans le buffer de lecture
// writePos	position dans le buffer d'ecriture
// charLeftRd	
// charLeftWr	
// fileSize	taille du fichier

class
{
  noextends;
  unsigned int	type : 4;
  int		fd;
  int		flags;
  mode_t	mode;
  char*		readBuff;
  char*		writeBuff;
  char*		readPos;
  char*		writePos;
  int		charLeftRd;
  int		charLeftWr;
  int		fileSize;
}		ClassStream;

// Prototypes
ClassStream*	streamOpenIO(ClassStream*,int);
ClassStream*	streamOpenFile(ClassStream*,char*,int,int);
void		streamClose(ClassStream*);
void		streamFlush(ClassStream*);
ClassStream*	newClassStream(ClassStream*);
void		deleteClassStream(ClassStream*);

#endif // __TRAC_STREAM_H__
