#include "trac_tcp.h"

static int	_tcpCreateSocket(int,int,char*);

// newClassTcp()
// constructeur de l'objet ClassTcp

ClassTcp*	newClassTcp(ClassTcp* this,int socketType,
			    int port,char* serverName)
{
  int		i;

  // initialisation de l'objet
  initParentClass(this,deleteClassTcp);
  // creation de la classe
  this->port = port;
  this->serverName = serverName;
  this->fdTableSize = getdtablesize();
  this->fdTable = malloc(sizeof(t_fonc_table)*this->fdTableSize);
  this->excepTable = malloc(sizeof(t_fonc_table)*NBR_EXCEP_MAX);
  for (i = 0;i < this->fdTableSize;i++)
    this->fdTable[i].state = FD_STATE_NOT_USED;
  for (i = 0;i < NBR_EXCEP_MAX;i++)
    this->excepTable[i].state = FD_STATE_NOT_USED;
  this->sdConnect = _tcpCreateSocket(socketType,port,serverName);
  return (this);
}

// deleteClassTcp()
// destructeur de l'objet ClassTcp

void	deleteClassTcp(ClassTcp* this)
{
  free(this->fdTable);
  free(this->excepTable);
}

// _tcpCreateSocket() -- PRIVATE
// cree une socket
// suivant le type de socket demande (pour un client ou pour un serveur),
// cette socket sera bindee ou connectee


static int		_tcpCreateSocket(int socketType,int port,
					 char* serverName)
{
  int			sd;
  struct sockaddr_in	addr;
  struct hostent*	hostInfo;
  
  sd = socket(AF_INET,SOCK_STREAM,0);
  addr.sin_family = AF_INET;
  addr.sin_port = htons(port);
  if (socketType == CLIENT_SOCK)
    {
      if ((hostInfo = gethostbyname(serverName)) == 0)
	TCP_ERROR_QUIT("gethostbyname error");
      bcopy(hostInfo->h_addr,&(addr.sin_addr.s_addr),hostInfo->h_length);
      if (connect(sd,(void*)&addr,sizeof(struct sockaddr_in)) < 0)
	TCP_ERROR_QUIT("Connection error");
    }
  else if (socketType == SERVER_SOCK)
    {
      addr.sin_addr.s_addr = htonl(INADDR_ANY);
      if (bind(sd,(struct sockaddr*)&addr,sizeof(addr)) < 0)   
	TCP_ERROR_QUIT("Server connecting");
      listen(sd,10);
    }
  return (sd);
}
