#ifndef	__TRAC_XM__
#define	__TRAC_XML__

#include <stdio.h>
#include "trac.h"
#include "trac_list.h"
#include "trac_exception.h"
#include "trac_string.h"

// dfinitions des types possibles pour un DataSet
// dfinitions publiques
#define	DATASET_ATOME		0
#define	DATASET_COMPOSITE	1

// dfinitions des status possibles de l'objet
// dfinitions prives
#define	XML_STATUS_CLOSED	0
#define	XML_STATUS_OPENED	1

// dfinitions des types de dplacement demands  la fonctioin prive
// _xmlGotoTagPath()
// dfinition prives
#define	GOTO_TAGPATH_READ	0
#define	GOTO_TAGPATH_WRITE	1

// dfinition de la chane de cration d'un nouveau fichier XML
// dfinition prive
#define	XML_NEW_FILE_STR	"<?xml version=\"1.0\"?>\n<DATA>\n</DATA>"

// dfinitions gnrales
// dfinitions prives
#define	INF			'<'
#define	SUP			'>'
#define	SLASH			'/'
#define	STR_SLASH		"/"
#define	SPACE			' '
#define	TAB			'\t'
#define	INTERROG		'?'
#define	SUFFIXE			".xml"
#define	DATA			"DATA"
#define	XML			"xml"
#define	BUFF_SIZE		4096

// dfinition d'un DataSet
typedef struct	sDataSet
{
  int		type;
  char*		name;
  char*		value;
  ClassList*	recordSet;
}		tDataSet;

// dfinition de l'objet ClassXml
class
{
  noextends;
  int	status;
  FILE*	file;
}	ClassXml;

// prototypes
int		xmlCreate(ClassXml* this, const char* fileName);
int		xmlOpen(ClassXml* this, const char* fileName);
int		xmlClose(ClassXml* this);
ClassList*	xmlGetData(ClassXml* this, const char* tagPath);
int		xmlAddData(ClassXml* this, const char* tagPath,
			   ClassList* values);
void		deleteRecordSet(ClassList* recordSet);

ClassXml*	newClassXml(ClassXml* this);
void		deleteClassXml(ClassXml* this);

#endif	// __TRAC_XML__
